# Algorithm for Correction of Marker Rotation and Displacement Errors

The algorithm is described and explained at report.pdf  

# Get mid Points (First Step)

Gets last PE point before each marker detection.  

--md and --pe are the logs from marker detection and pose estimator from the path that needs to be optimized, this path needs the global pose update by markers turned on.  

```
$ python script/get_mid_points.py --marker=data/logs/20180516-134720/marker/pose.csv --pe=data/logs/20180516-134720/pe/pose.csv > mid_data
```

# Parse Marker Error (Second Step)

Parse log from path without global position update by marker detection  

```
$ python script/parse_marker_error.py --map=data/gvz_ext.yml --md=data/logs/20180516-133414/marker/pose.csv > correction_data
```  

If no such path was captured, then the --md option should receive the same marker log that was used in the first step, in this case the "True values" in the algorithm's plot shall be ignored.


# Run Algorithm

Will plot the result and also create a file "fixed_gvz.yml", which is the gvz yml with the new values for the theta

```
$ python script/algorithm.py --inter=mid_data --correction=correction_data
```


# Plotter

Plots a path. The --show option specifies which logs need to be included in the plot (m=marker, p=pose, c=ctrl, i=inter). The inter log can be obtained from the First Step.  

```
$ python script/plotter.py --map=data/gvz_ext.yml --log=data/logs/20180516-134720 --show=mpci
```
